import sys
sys.path.append('/your/dir/to/tensorflow/models') # point to your tensorflow dir
sys.path.append('/your/dir/to/tensorflow/models/slim') # point ot your slim dir

from tensorflow.python.client import device_lib
print(device_lib.list_local_devices())

import tensorflow as tf
#import scipy.misc
import numpy as np
import scipy.io
#tf.global_variables_initializer()
MODEL_DIR = r'E:\Nikita_Bhatt_GPU\DCMH_tensorflow\trial\data\imagenet-vgg-f.mat'
def img_net_strucuture(input_image, bit):
    
    data = scipy.io.loadmat(MODEL_DIR)
    print('input_image' , input_image)
    
    layers = (
		'conv1', 'relu1', 'norm1', 'pool1','conv2', 'relu2', 'norm2', 'pool2','conv3', 'relu3', 'conv4', 'relu4', 'conv5',
		'relu5', 'pool5','fc6', 'relu6', 'fc7', 'relu7','fc8')
    weights = data['layers'][0]
	
    for key in data.keys():
        print(key)
	
    mean = data['normalization'][0][0][0]
    net = {}
    ops = []
	#print("input_image",input_image)
    current = tf.convert_to_tensor(input_image,dtype='float32')
    for i, name in enumerate(layers[:-1]):
        if name.startswith('conv'):
            kernels, bias = weights[i][0][0][0][0]
			# matconvnet: weights are [width, height, in_channels, out_channels]
			# tensorflow: weights are [height, width, in_channels, out_channels]
			#kernels = np.transpose(kernels, (1, 0, 2, 3))

            bias = bias.reshape(-1)
            pad = weights[i][0][0][1]
			#print("pad type", pad.dtype)
            stride = weights[i][0][0][4]
			
			
            current = _conv_layer(current,kernels,bias,pad,stride,i,ops,net)
        elif name.startswith('relu'):
            current = tf.nn.relu(current)
        elif name.startswith('pool'):
            stride = weights[i][0][0][1]
            pad = weights[i][0][0][2]
            area = weights[i][0][0][5]
            current = _pool_layer(current,stride,pad,area)
        elif name.startswith('fc'):
            kernels, bias = weights[i][0][0][0][0]
			# matconvnet: weights are [width, height, in_channels, out_channels]
			# tensorflow: weights are [height, width, in_channels, out_channels]
			#kernels = np.transpose(kernels, (1, 0, 2, 3))

            bias = bias.reshape(-1)
            current = _full_conv(current,kernels,bias,i,ops,net)
        elif name.startswith('norm'):
            current = tf.nn.local_response_normalization(current, depth_radius=2, bias=2.000, alpha=0.0001, beta=0.75)
        net[name] = current
    W_fc8 = tf.random.normal([4096, bit], stddev=1.0) * 0.01
    #print("W_fc8 " , W_fc8)



    b_fc8 = tf.random.normal([bit],stddev = 1.0) * 0.01
    #print("b_fc8 " , b_fc8)

    w = tf.Variable(W_fc8, name='w' + str(20))
    b = tf.Variable(b_fc8, name='bias' + str(20))
    
    #print("w " ,w)
    #print("b " ,b)
    
    #W1 = tf.Variable(tf.random_uniform([1], -1.0, 1.0))
    init = tf.compat.v1.initialize_all_variables()
    sess = tf.compat.v1.Session()
    sess.run(init)
    array = w.eval(sess)
    array1=b.eval(sess)
    #print ("w :",array)
    #print ("b :",array1)


	### debugging...................
	# layer8 = scipy.io.loadmat('data/wb-image.mat')
	#
	# w = tf.Variable(np.squeeze(layer8['w8']) * 0.01, name='w' + str(20))
	# b = tf.Variable(np.squeeze(layer8['b8']) * 0.01, name='bias' + str(20))

    ops.append(w)
    ops.append(b)
    print('current tensor :',current)
#    import tensorflow as tf
    #W1 = tf.Variable(tf.random_uniform([1], -1.0, 1.0))
    
    
    
    fc8 = tf.matmul(tf.squeeze(current),w) + b
    #fc8 = tf.matmul(current,w) + b
	#print("w", w ,"current" , current ,"b" ,b)    
    #tf.squeeze(fc8)
    
    
    net['weigh21'] = w
    net['b21'] = b
    net[layers[-1]] = fc8
    print("net" ,net ,"fc8" , fc8)
	
        
	
    return net,mean   
    

def _conv_layer(input, weights, bias,pad,stride,i,ops,net):
	pad = pad[0]
	pad = pad.astype(np.int32)
	stride= stride[0]
	print("line 79",pad)
	input = tf.pad(input, [[0, 0], [pad[0], pad[1]], [pad[2], pad[3]], [0, 0]], "CONSTANT")
	w = tf.Variable(weights,name='w'+str(i),dtype='float32')
	b = tf.Variable(bias,name='bias'+str(i),dtype='float32')
	ops.append(w)
	ops.append(b)
	net['weights' + str(i)] = w
	net['b' + str(i)] = b
	conv = tf.nn.conv2d(input, w, strides=[1,stride[0],stride[1],1],padding='VALID',name='conv'+str(i))
	return tf.nn.bias_add(conv, b,name='add'+str(i))

def _full_conv(input, weights, bias,i,ops,net):
	w = tf.Variable(weights, name='w' + str(i),dtype='float32')
	b = tf.Variable(bias, name='bias' + str(i),dtype='float32')
	ops.append(w)
	ops.append(b)
	net['weights' + str(i)] = w
	net['b' + str(i)] = b
	conv = tf.nn.conv2d(input, w,strides=[1,1,1,1],padding='VALID',name='fc'+str(i))
	return tf.nn.bias_add(conv, b,name='add'+str(i))

def _pool_layer(input,stride,pad,area):
	pad = pad[0]
	pad = pad.astype(np.int32)
	print("pad",pad)
	area = area[0]
	stride = stride[0]
	input = tf.pad(input, [[0, 0], [pad[0], pad[1]], [pad[2], pad[3]], [0, 0]], "CONSTANT")
	return tf.nn.max_pool(input, ksize=[1, area[0], area[1], 1], strides=[1,stride[0],stride[1],1],padding='VALID')

def preprocess(image, mean_pixel):
	return image - mean_pixel


def unprocess(image, mean_pixel):
	return image + mean_pixel

def get_meanpix(data_path):
	data = scipy.io.loadmat(data_path)
	mean = data['normalization'][0][0][0]
	return mean
